import os
import clipboard

from src.order import Order


def return_func():
    return False


def add_item():
    print('Add item')
    options = Order.list_options()
    for i, x in enumerate(options):
        print(f'{i+1} - {x}')
    print('x - return to main menu')
    print_summary()
    print('\n:')
    chosen_item = input()

    if chosen_item == 'x':
        return
    try:
        chosen_item = int(chosen_item) - 1
    except ValueError:
        print(f'Invalid option {chosen_item}')
        add_item()
        return
    if not chosen_item < len(options):
        print('Invalid Item')
    else:
        Order.add_item(options[chosen_item])

    os.system('clear')
    add_item()


def print_summary():
    print('Summary:')
    summary = Order.get_string()
    clipboard.copy(summary)
    print(summary)


def parse_ifood_string():
    print('parse_ifood_string')


def remove_latest_item():
    Order.remove_latest_item()


def clear_all_items():
    Order.clear_all_items()


main_menu_options = {
    '1': {'func': add_item, 'name': 'Add item'},
    '2': {'func': print_summary, 'name': 'Copy Summary/PDV to Clipboard'},
    '3': {'func': parse_ifood_string, 'name': 'Parse Ifood into PDVS'},
    '4': {'func': remove_latest_item, 'name': 'Remove Last item'},
    '5': {'func': clear_all_items, 'name': 'Clear Order'},
    '6': {'func': return_func, 'name': 'Exit'},
}


def print_main_menu_options():
    print("Choose an Option:")
    for k, c in main_menu_options.items():
        print(f"{k} - {c['name']}")


def menu():
    should_not_exit = True
    while should_not_exit:
        print_main_menu_options()
        chosen_option = input()

        os.system('clear')

        chosen_option = main_menu_options.get(chosen_option)
        if chosen_option is None:
            print('Choose a valid option.')
        else:
            option_callable = chosen_option['func']
            should_not_exit = option_callable()
            should_not_exit = True if should_not_exit is None else should_not_exit


if __name__ == '__main__':
    os.system('clear')
    if os.getenv('TERM') is None:
        os.environ['TERM'] = 'xterm'
    Order.load_menu()
    menu()
